// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Exprbldr.pas' rev: 3.00

#ifndef ExprbldrHPP
#define ExprbldrHPP
#include <Exprfns.hpp>
#include <ExPars.hpp>
#include <parstype.hpp>
#include <DBCtrls.hpp>
#include <DBTables.hpp>
#include <Db.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Exprbldr
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TUserData;
class PASCALIMPLEMENTATION TUserData : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	System::AnsiString FName;
	void *FData;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall ReadFromStream(Classes::TStream* S);
	virtual void __fastcall WriteToStream(Classes::TStream* S);
	__property System::AnsiString Name = {read=FName, write=FName};
	__property void * Data = {read=FData, write=FData};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TUserData(void) { }
	
public:
	/* TObject.Create */ __fastcall TUserData(void) : Classes::TPersistent() { }
	
};

class DELPHICLASS TUserDataList;
class PASCALIMPLEMENTATION TUserDataList : public Classes::TStringList 
{
	typedef Classes::TStringList inherited;
	
private:
	void __fastcall FreeUserData(void);
	HIDESBASE void __fastcall QuickSort(int L, int R);
	
protected:
	virtual System::AnsiString __fastcall Get(int Index);
	virtual void __fastcall Put(int Index, const System::AnsiString S);
	virtual void __fastcall PutObject(int Index, System::TObject* AObject);
	
public:
	virtual bool __fastcall Find(const System::AnsiString S, int &Index);
	virtual void __fastcall Clear(void);
	virtual void __fastcall Delete(int Index);
	virtual void __fastcall Sort(void);
	virtual void __fastcall LoadFromStream(Classes::TStream* S);
	virtual void __fastcall SaveToStream(Classes::TStream* S);
public:
	/* TStringList.Destroy */ __fastcall virtual ~TUserDataList(void) { }
	
public:
	/* TObject.Create */ __fastcall TUserDataList(void) : Classes::TStringList() { }
	
};

typedef System::TMetaClass*TUserDataClass;

typedef System::TMetaClass*TUserDataListClass;

enum TUDRepresentType { udrt_Name, udrt_Index };

class DELPHICLASS TUserDataListBox;
class PASCALIMPLEMENTATION TUserDataListBox : public Stdctrls::TListBox 
{
	typedef Stdctrls::TListBox inherited;
	
private:
	Dbctrls::TFieldDataLink* FDataLink;
	Stdctrls::TCustomEdit* FExprControl;
	TUDRepresentType FRepresentAs;
	TUserDataList* FUserData;
	void __fastcall DataChange(System::TObject* Sender);
	void __fastcall UpdateData(System::TObject* Sender);
	void __fastcall UserDataChanged(System::TObject* Sender);
	void __fastcall AddToExpression(void);
	System::AnsiString __fastcall GetRepresentation(int AnIndex);
	System::AnsiString __fastcall GetDataField(void);
	Db::TDataSource* __fastcall GetDataSource(void);
	Db::TField* __fastcall GetField(void);
	bool __fastcall GetReadOnly(void);
	void __fastcall GetUserData(void);
	void __fastcall FlushList(void);
	void __fastcall SetDataField(const System::AnsiString Value);
	void __fastcall SetDataSource(Db::TDataSource* Value);
	void __fastcall SetReadOnly(bool Value);
	void __fastcall SetUserData(TUserDataList* Value);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	DYNAMIC void __fastcall DblClick(void);
	__property Dbctrls::TFieldDataLink* DataLink = {read=FDataLink};
	
public:
	__fastcall virtual TUserDataListBox(Classes::TComponent* AOwner);
	__fastcall virtual ~TUserDataListBox(void);
	bool __fastcall EditUserData(void);
	void __fastcall ModifyUserData(void);
	void __fastcall UpdateList(void);
	__property Db::TField* Field = {read=GetField};
	__property TUserDataList* UserData = {read=FUserData, write=SetUserData};
	
__published:
	__property Stdctrls::TCustomEdit* ExpressionControl = {read=FExprControl, write=FExprControl};
	__property Items  = {stored=false};
	__property TUDRepresentType RepresentAs = {read=FRepresentAs, write=FRepresentAs, default=0};
	__property bool ReadOnly = {read=GetReadOnly, write=SetReadOnly, default=0};
	__property System::AnsiString UserDataField = {read=GetDataField, write=SetDataField};
	__property Db::TDataSource* UserDataSource = {read=GetDataSource, write=SetDataSource};
public:
	/* TWinControl.CreateParented */ __fastcall TUserDataListBox(HWND ParentWindow) : Stdctrls::TListBox(
		ParentWindow) { }
	
};

class DELPHICLASS TExprSolver;
class PASCALIMPLEMENTATION TExprSolver : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Expars::TCustomParser* FExprParser;
	TUserDataList* FUserData;
	Dbctrls::TFieldDataLink* FExprDataLink;
	Dbctrls::TFieldDataLink* FUserDataLink;
	System::AnsiString FVarsINIFile;
	System::AnsiString FVarsINISection;
	Db::TDataSource* FVarsSource;
	Classes::TNotifyEvent FOnBeforeEvaluate;
	Classes::TNotifyEvent FOnAfterEvaluate;
	void __fastcall ExprDataChange(System::TObject* Sender);
	void __fastcall UserDataChange(System::TObject* Sender);
	void __fastcall GetExprFromDataset(void);
	void __fastcall GetUserDatafromDataset(void);
	Classes::TStrings* __fastcall GetExpression(void);
	System::AnsiString __fastcall GetExprField(void);
	Db::TDataSource* __fastcall GetExprSource(void);
	System::AnsiString __fastcall GetUserDataField(void);
	Db::TDataSource* __fastcall GetUserDataSource(void);
	void __fastcall SetExprField(System::AnsiString Value);
	void __fastcall SetExpression(Classes::TStrings* Value);
	void __fastcall SetExprSource(Db::TDataSource* Value);
	void __fastcall SetExprParser(Expars::TCustomParser* Value);
	void __fastcall SetUserData(TUserDataList* Value);
	void __fastcall SetUserDataField(System::AnsiString Value);
	void __fastcall SetUserDataSource(Db::TDataSource* Value);
	void __fastcall SetVarsSource(Db::TDataSource* Value);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
public:
	__fastcall virtual TExprSolver(Classes::TComponent* AnOwner);
	__fastcall virtual ~TExprSolver(void);
	void __fastcall Prepare(void);
	Extended __fastcall F(const Extended * AParams, const int AParams_Size);
	__property Classes::TStrings* Expression = {read=GetExpression, write=SetExpression};
	__property TUserDataList* UserData = {read=FUserData, write=SetUserData};
	
__published:
	__property System::AnsiString ExprField = {read=GetExprField, write=SetExprField};
	__property Db::TDataSource* ExprSource = {read=GetExprSource, write=SetExprSource};
	__property Expars::TCustomParser* ExprParser = {read=FExprParser, write=SetExprParser};
	__property System::AnsiString UserDataField = {read=GetUserDataField, write=SetUserDataField};
	__property Db::TDataSource* UserDataSource = {read=GetUserDataSource, write=SetUserDataSource};
	__property System::AnsiString VarsINIFile = {read=FVarsINIFile, write=FVarsINIFile};
	__property System::AnsiString VarsINISection = {read=FVarsINISection, write=FVarsINISection};
	__property Db::TDataSource* VarsSource = {read=FVarsSource, write=SetVarsSource};
	__property Classes::TNotifyEvent OnBeforeEvaluate = {read=FOnBeforeEvaluate, write=FOnBeforeEvaluate
		};
	__property Classes::TNotifyEvent OnAfterEvaluate = {read=FOnAfterEvaluate, write=FOnAfterEvaluate};
		
};

class DELPHICLASS TExprBuilderDlg;
typedef bool __fastcall (__closure *TEditUserDataEvent)(TExprBuilderDlg* ExprBuilder, TUserDataList* 
	&DataList, int Index, TUserData* &UserData);

class PASCALIMPLEMENTATION TExprBuilderDlg : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Expars::TCustomParser* FExprParser;
	Exprfns::TExprFunctions* FExprFuncs;
	Dbctrls::TFieldDataLink* FExprDataLink;
	Dbctrls::TFieldDataLink* FUserDataLink;
	System::AnsiString FTitle;
	Classes::TStrings* FExpression;
	TUserDataList* FUserData;
	bool FIsShowing;
	Forms::TForm* FBuilderDlg;
	TUDRepresentType FUDRepresentAs;
	TEditUserDataEvent FOnEditUserData;
	Stdctrls::TDrawItemEvent FOnDrawUserData;
	bool __fastcall CheckExprField(System::AnsiString Value);
	bool __fastcall CheckUserDataField(System::AnsiString Value);
	void __fastcall ExprDataChange(System::TObject* Sender);
	void __fastcall UserDataChange(System::TObject* Sender);
	void __fastcall UpdateExpression(System::TObject* Sender);
	void __fastcall UpdateUserData(System::TObject* Sender);
	void __fastcall FlushExpression(void);
	void __fastcall FlushUserData(void);
	bool __fastcall EditExpression(void);
	bool __fastcall EditUserData(void);
	void __fastcall ModifyExpression(void);
	void __fastcall ModifyUserData(void);
	void __fastcall GetExprFromDataset(void);
	void __fastcall GetUserDatafromDataset(void);
	System::AnsiString __fastcall GetExprField(void);
	Db::TDataSource* __fastcall GetExprSource(void);
	Classes::TStrings* __fastcall GetExpression(void);
	TUserDataList* __fastcall GetUserData(void);
	System::AnsiString __fastcall GetUserDataField(void);
	Db::TDataSource* __fastcall GetUserDataSource(void);
	void __fastcall SetExpression(Classes::TStrings* Value);
	void __fastcall SetExprField(System::AnsiString Value);
	void __fastcall SetExprSource(Db::TDataSource* Value);
	void __fastcall SetExprFuncs(Exprfns::TExprFunctions* Value);
	void __fastcall SetExprParser(Expars::TCustomParser* Value);
	void __fastcall SetUserDataField(System::AnsiString Value);
	void __fastcall SetUserDataSource(Db::TDataSource* Value);
	void __fastcall SetUserData(TUserDataList* Value);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
public:
	__fastcall virtual TExprBuilderDlg(Classes::TComponent* AnOwner);
	__fastcall virtual ~TExprBuilderDlg(void);
	bool __fastcall Execute(void);
	__property Classes::TStrings* Expression = {read=GetExpression, write=SetExpression};
	__property TUserDataList* UserData = {read=GetUserData, write=SetUserData};
	
__published:
	__property System::AnsiString ExprField = {read=GetExprField, write=SetExprField};
	__property Db::TDataSource* ExprSource = {read=GetExprSource, write=SetExprSource};
	__property Exprfns::TExprFunctions* ExprFunctions = {read=FExprFuncs, write=SetExprFuncs};
	__property Expars::TCustomParser* ExprParser = {read=FExprParser, write=SetExprParser};
	__property TUDRepresentType UDRepresentAs = {read=FUDRepresentAs, write=FUDRepresentAs, default=0};
		
	__property System::AnsiString UserDataField = {read=GetUserDataField, write=SetUserDataField};
	__property Db::TDataSource* UserDataSource = {read=GetUserDataSource, write=SetUserDataSource};
	__property System::AnsiString Title = {read=FTitle, write=FTitle};
	__property TEditUserDataEvent OnEditUserData = {read=FOnEditUserData, write=FOnEditUserData};
	__property Stdctrls::TDrawItemEvent OnDrawUserData = {read=FOnDrawUserData, write=FOnDrawUserData};
		
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::AnsiString __fastcall ReadStr(Classes::TStream* S);
extern PACKAGE void __fastcall WriteStr(Classes::TStream* S,  System::ShortString &AStr);
extern PACKAGE TUserDataList* __fastcall LoadBlobUserData(Db::TBlobField* AField);
extern PACKAGE void __fastcall SaveBlobUserData(Db::TBlobField* AField, TUserDataList* AnUserData);
extern PACKAGE TUserData* __fastcall CopyUserData(TUserData* AnUserData);
extern PACKAGE TUserDataList* __fastcall CopyUserDataList(TUserDataList* AList);

}	/* namespace Exprbldr */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Exprbldr;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Exprbldr
